
#line 1 "lel_parser.rl"
#include "lel.hpp"
#include <fmt/core.h>
#include <iostream>


#line 34 "lel_parser.rl"



#line 8 "lel_parser.cpp"
static const char _LELParser_actions[] = {
	0, 1, 1, 1, 2, 1, 3, 1, 
	4, 1, 5, 1, 6, 1, 9, 1, 
	10, 1, 11, 2, 0, 7, 2, 0, 
	8, 2, 4, 1, 2, 4, 5
};

static const char _LELParser_key_offsets[] = {
	0, 0, 4, 18, 20, 24, 35, 47, 
	52, 54, 57
};

static const char _LELParser_trans_keys[] = {
	32, 91, 9, 13, 32, 40, 42, 46, 
	60, 62, 94, 95, 9, 13, 65, 90, 
	97, 122, 48, 57, 41, 44, 48, 57, 
	40, 42, 46, 60, 62, 94, 95, 65, 
	90, 97, 122, 32, 93, 95, 124, 9, 
	13, 48, 57, 65, 90, 97, 122, 32, 
	93, 124, 9, 13, 48, 57, 41, 48, 
	57, 32, 91, 9, 13, 0
};

static const char _LELParser_single_lengths[] = {
	0, 2, 8, 0, 2, 7, 4, 3, 
	0, 1, 2
};

static const char _LELParser_range_lengths[] = {
	0, 1, 3, 1, 1, 2, 4, 1, 
	1, 1, 1
};

static const char _LELParser_index_offsets[] = {
	0, 0, 4, 16, 18, 22, 32, 41, 
	46, 48, 51
};

static const char _LELParser_indicies[] = {
	0, 2, 0, 1, 3, 4, 5, 6, 
	7, 7, 6, 8, 3, 8, 8, 1, 
	9, 1, 10, 11, 12, 1, 4, 5, 
	6, 7, 7, 6, 8, 8, 8, 1, 
	13, 15, 14, 16, 13, 14, 14, 14, 
	1, 17, 18, 19, 17, 1, 20, 1, 
	21, 22, 1, 23, 2, 23, 1, 0
};

static const char _LELParser_trans_targs[] = {
	1, 0, 2, 2, 3, 5, 5, 5, 
	6, 4, 5, 8, 4, 7, 6, 10, 
	2, 7, 10, 2, 9, 5, 9, 10
};

static const char _LELParser_trans_actions[] = {
	0, 0, 3, 0, 0, 13, 5, 11, 
	17, 15, 19, 19, 0, 7, 0, 28, 
	25, 0, 9, 1, 15, 22, 0, 0
};

static const int LELParser_start = 1;
static const int LELParser_first_final = 10;
static const int LELParser_error = 0;

static const int LELParser_en_main = 1;


#line 37 "lel_parser.rl"

bool LELParser::parse(std::string input) {
  reset();
  int cs = 0;
  const char *start = nullptr;
  const char *begin = input.data();
  const char *p = input.data();
  const char *pe = p + input.size();
  std::string tk;

  
#line 84 "lel_parser.cpp"
	{
	cs = LELParser_start;
	}

#line 48 "lel_parser.rl"
  
#line 87 "lel_parser.cpp"
	{
	int _klen;
	unsigned int _trans;
	const char *_acts;
	unsigned int _nacts;
	const char *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_keys = _LELParser_trans_keys + _LELParser_key_offsets[cs];
	_trans = _LELParser_index_offsets[cs];

	_klen = _LELParser_single_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (unsigned int)(_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _LELParser_range_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += (unsigned int)((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	_trans = _LELParser_indicies[_trans];
	cs = _LELParser_trans_targs[_trans];

	if ( _LELParser_trans_actions[_trans] == 0 )
		goto _again;

	_acts = _LELParser_actions + _LELParser_trans_actions[_trans];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 )
	{
		switch ( *_acts++ )
		{
	case 0:
#line 9 "lel_parser.rl"
	{tk = input.substr(start - begin, p - start); }
	break;
	case 1:
#line 11 "lel_parser.rl"
	{ col(); }
	break;
	case 2:
#line 12 "lel_parser.rl"
	{ ltab(); }
	break;
	case 3:
#line 13 "lel_parser.rl"
	{ valign((*p)); }
	break;
	case 4:
#line 14 "lel_parser.rl"
	{ id(input.substr(start - begin, p - start)); }
	break;
	case 5:
#line 15 "lel_parser.rl"
	{ row(); }
	break;
	case 6:
#line 16 "lel_parser.rl"
	{ align((*p)); }
	break;
	case 7:
#line 17 "lel_parser.rl"
	{ setwidth(std::stoi(tk)); }
	break;
	case 8:
#line 18 "lel_parser.rl"
	{ setheight(std::stoi(tk)); }
	break;
	case 9:
#line 19 "lel_parser.rl"
	{ expand(); }
	break;
	case 10:
#line 27 "lel_parser.rl"
	{ start = p; }
	break;
	case 11:
#line 30 "lel_parser.rl"
	{start = p;}
	break;
#line 196 "lel_parser.cpp"
		}
	}

_again:
	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	_out: {}
	}

#line 49 "lel_parser.rl"

  bool good = pe - p == 0;
  if(good) {
    finalize();
  } else {
    fmt::println("error at");
    std::cout << p;
  }
  return good;
}
